#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rebuild_pipe_connection4xi.py">
#<abstract4xi abstract = "providing function rebuild_pipe_connection4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/> 
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API 
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'rebuild_pipe_connection4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:
    from multiprocessing.reduction import rebuild_pipe_connection
except:
    print("pipeconnection4xi.py: *** failed in from multiprocessing.reduction import rebuild_pipe_connection ***")
try:
    from multiprocessing.connection import PipeConnection
except:
    print("pipeconnection4xi.py: *** failed in from multiprocessing.connection import PipeConnection ***")        
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipeconnection4xi import PipeConnection4Xi
from print4xi import print4xi
from rebuild_handle4xi import rebuild_handle4xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "rebuild_pipe_connection4xi" usage = "
#   reduction.py
#       reduce_pipe_connection(conn):
#           return rebuild_pipe_connection, (dh, conn.readable, conn.writable)
#   reduce_pipe_connection4xi.py
#       reduce_pipe_connection4xi(conn):
#           return rebuild_pipe_connection4xi, (dh2xi, conn.readable, conn.writable)       
#"> 
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
def rebuild_pipe_connection4xi(dh, readable, writable):
    '''
    rebuilds pipe connection - Windows only function 
    '''  
    class2print = "rebuild_pipe_connection4xi"
    method2print = "rebuild_pipe_connection4xi"  
    
    if sys.platform == 'win32':
             
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3) - Windows 
        # -----------------------------------------------------------------------------------------     
            
        message2print = "{(Step 1/3a) started" + "; rebuild-pipe-connection4xi-started: " + str(rebuild_pipe_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            
        message2print = "{(Step 1/3b) passed" + "; dh-passed-to-rebuild-pipe-connection4xi: " + str(dh) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                      
            
        message2print = "{(Step 1/3c) passed" + "; readable-passed-to-rebuild-pipe-connection4xi: " + str(readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                    
            
        message2print = "{(Step 1/3d) passed" + "; writable-passed-to-rebuild-pipe-connection4xi: " + str(writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
          
        
        # -----------------------------------------------------------------------------------------    
        # (Step 2/3) - Windows  
        # -----------------------------------------------------------------------------------------     
    
        handle2xi = dh.detach()
        
        message2print = "{(Step 2/3b) set" + "; handle2xi-set-by-rebuild-pipe-connection4xi to: " + str(handle2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
            
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3) - Windows  
        # -----------------------------------------------------------------------------------------     
        message2print = "{(Step 3/3a) passing" + "; handle2xi-passing-to-PipeConnection4Xi-by-rebuild-pipe-connection4xi: " + str(handle2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        message2print = "{(Step 3/3b) passing" + "; readable-passing-to-PipeConnection4Xi-by-rebuild-pipe-connection4xi: " + str(readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
              
        message2print = "{(Step 3/3c) passing" + "; writable-passing-to-PipeConnection4Xi-by-rebuild-pipe-connection4xi: " + str(writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        return PipeConnection4Xi(handle2xi, readable, writable)
    else:
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3) - non-Windows should not be called! 
        # -----------------------------------------------------------------------------------------     
          
        message2print = "{(Step 1/3a) started" + "; rebuild-pipe-connection4xi-started: " + str(rebuild_pipe_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b) warned" + "; usage-warned-by-rebuild-pipe-connection4xi: " + str("** rebuild_pipe_connection4xi to be called only in Windows systems  **")  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
        message2print = "{(Step 1/3c) returning" + "; rebuild-pipe-connection4xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        
        return PipeConnection(handle, readable, writable)
           
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rebuild_pipe_connection4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
